<template>
  <h1>{{ msg }} - count {{ count }}</h1>
  <button v-show="showIncrease" @click="counting(1)">Increase</button>
  <button v-show="showDecrease" @click="counting(-1)">Decrease</button>
  <br />
  <button @click="changeMsg()">
    Change to
    <span v-if="showHello">World</span>
    <span v-else>Hello</span>
  </button>
  <section>
    <BookList header="Book for Sale" :books="unsoldBooks"  />
    <BookList header="Sold Book" :books="soldBooks"  />
  </section>
</template>

<script>
import BookList from './BookList.vue';

export default {
  name: "HelloWorld",
  components: {
    BookList
  },
  data() {
    return {
      msg: "Hello",
      count: 0,
      showDecrease: false,
      showIncrease: true,
      showHello: true,
      books: [
        {
          id: "asis",
          title: "A Study in Scarlet",
          author: "Sir A. C. Doyle",
          url: "https://en.wikipedia.org/wiki/A_Study_in_Scarlet",
          imageUrl:
            "https://upload.wikimedia.org/wikipedia/commons/archive/2/2c/20081206002312%21ArthurConanDoyle_AStudyInScarlet_annual.jpg",
          isSold: false,
        },
        {
          id: "asof",
          title: "The Sign of the Four",
          author: "Sir A. C. Doyle",
          url: "https://en.wikipedia.org/wiki/The_Sign_of_the_Four",
          imageUrl:
            'https://upload.wikimedia.org/wikipedia/commons/thumb/a/af/"The_Sign_of_the_Four"_in_Lippincott’s_Monthly_Magazine_%281890%29.jpg/159px-"The_Sign_of_the_Four"_in_Lippincott’s_Monthly_Magazine_%281890%29.jpg',
          isSold: true,
        },
        {
          id: "hfb",
          title: "His Last Bow",
          author: "Sir A. C. Doyle",
          url: "https://en.wikipedia.org/wiki/His_Last_Bow",
          imageUrl:
            "https://upload.wikimedia.org/wikipedia/commons/3/3c/His_Last_Bow_1917_cover.jpg",
          isSold: false,
        },
      ],
    };
  },
  methods: {
    // changeMsg(title) {
    //     this.msg = title
    // },
    changeMsg() {
      this.msg = this.msg === "Hello" ? "World" : "Hello";
      this.showHello = this.msg === "Hello";
    },
    // increase() {
    //     if (this.count + 1 <= 10) {
    //         this.count++;
    //     }
    //     this.showIncrease = this.count < 10
    //     this.showDecrease = this.count > 0
    // },
    // decrease() {
    //     if (this.count - 1 >= 0) {
    //         this.count--;
    //     }
    //     this.showIncrease = this.count < 10
    //     this.showDecrease = this.count > 0
    // },
    counting(value) {
      if ((value > 0 && this.count < 10) || (value < 0 && this.count > 0)) {
        this.count = this.count + value;
      }
      this.showIncrease = this.count < 10;
      this.showDecrease = this.count > 0;
    },
  },
  computed: {
    soldBooks() {
      return this.books.filter(book => book.isSold)
    },
    unsoldBooks() {
      return this.books.filter(book => !book.isSold)
    },
  }
};
</script>

<style>
.book {
  width: 300px;
  margin: 10px 0;
  background-color: darkcyan;
}
img {
  width: 200px;
}
.sold {
  background-color: darkred;
}
</style>